
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>

#define PNG_DEBUG 3
#include <png.h>

#define byte char

int x, y;

int width, height;
png_byte color;
png_byte depth;

png_structp pngptr;
png_infop info;
int number_of_passes;
byte* imgData;
byte* imgData2;

byte* loadfile(char* filename)
{
	char headerX[8];	// 8 is the maximum size that can be checked
	png_bytep header = (png_bytep)headerX;

	FILE *fp = fopen(filename, "rb");
	fread(header, 1, 8, fp);

	/* initialize stuff */
	pngptr = png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
	
	if (!pngptr)
		exit(-1);

	info = png_create_info_struct(pngptr);
	if (!info)
		exit(-1);

	if (setjmp(png_jmpbuf(pngptr)))
		exit(-1);

	png_init_io(pngptr, fp);
	png_set_sig_bytes(pngptr, 8);

	png_read_info(pngptr, info);

	width = info->width;
	height = info->height;
	color = info->color_type;
	depth = info->bit_depth;

	number_of_passes = png_set_interlace_handling(pngptr);
	png_read_update_info(pngptr, info);


	if (setjmp(png_jmpbuf(pngptr)))
		exit(-1);

	png_bytep* row_pointers = (png_bytep*) malloc(height * sizeof(png_bytep));
	for (y=0; y<height; y++)
		row_pointers[y] = (png_byte*) malloc(info->rowbytes);

	png_read_image(pngptr, row_pointers);

    fclose(fp);

	//convert to single line
	byte* target = (byte*) malloc(width * height * 3);
	for(int y = 0; y < height; y++){
		png_byte* rowData = row_pointers[y];
		for(int x = 0; x < width; x++){
			png_byte* ptr = &(rowData[x*3]);

			*(target + (y * width * 3) + (x * 3) + 0) = (ptr[0]);
			*(target + (y * width * 3) + (x * 3) + 1) = (ptr[1]);
			*(target + (y * width * 3) + (x * 3) + 2) = (ptr[2]);
		}
	}

	free(row_pointers);

	return target;
}


void writesinglechannelpngfile(char* file_name, byte* toWrite)
{
	//de-streamline
	png_bytep* nurows = (png_bytep*)png_malloc(pngptr, height*sizeof(png_bytep));
	for(int y = 0; y < height; y++){
		nurows[y] = (png_bytep)png_malloc(pngptr, width);
		png_byte* currow = nurows[y];
		for(int x = 0; x < width; x++){
			png_byte* nurow = &(currow[x]);
			*(nurow) = *(toWrite + (y * width) + (x) + 0);
		}
	}

	FILE *fp = fopen(file_name, "wb");
	if (!fp)
		exit(-1);

	pngptr = png_create_write_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
	
	if (!pngptr)
		exit(-1);

	info = png_create_info_struct(pngptr);
	if (!info)
		exit(-1);

	if (setjmp(png_jmpbuf(pngptr)))
		exit(-1);

	png_init_io(pngptr, fp);


	if (setjmp(png_jmpbuf(pngptr)))
		exit(-1);

	png_set_IHDR(pngptr, info, width, height,
		     8, PNG_COLOR_TYPE_GRAY, PNG_INTERLACE_NONE,
		     PNG_COMPRESSION_TYPE_BASE, PNG_FILTER_TYPE_BASE);

	png_write_info(pngptr, info);


	if (setjmp(png_jmpbuf(pngptr)))
		exit(-1);

	png_write_image(pngptr, nurows);


	if (setjmp(png_jmpbuf(pngptr)))
		exit(-1);

	png_write_end(pngptr, NULL);

	free(nurows);
    fclose(fp);
}

void writepngfile(char* file_name, int cwidth, int cheight, byte* toWrite)
{
	//de-streamline
	png_bytep* nurows = (png_bytep*)png_malloc(pngptr, cheight*sizeof(png_bytep));
	for(int y = 0; y < cheight; y++){
		nurows[y] = (png_bytep)png_malloc(pngptr, cwidth * 3);
		png_byte* currow = nurows[y];
		for(int x = 0; x < cwidth; x++){
			png_byte* nurow = &(currow[x * 3]);
			*(nurow) = *(toWrite + (y * cwidth * 3) + (x * 3) + 0);
			*(nurow + 1) = *(toWrite + (y * cwidth * 3) + (x * 3) + 1);
			*(nurow + 2) = *(toWrite + (y * cwidth * 3) + (x * 3) + 2);
		}
	}

	FILE *fp = fopen(file_name, "wb");
	if (!fp)
		exit(-1);

	pngptr = png_create_write_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
	
	if (!pngptr)
		exit(-1);

	info = png_create_info_struct(pngptr);
	if (!info)
		exit(-1);

	if (setjmp(png_jmpbuf(pngptr)))
		exit(-1);

	png_init_io(pngptr, fp);

	if (setjmp(png_jmpbuf(pngptr)))
		exit(-1);

	png_set_IHDR(pngptr, info, cwidth, cheight,
		     8, PNG_COLOR_TYPE_RGB, PNG_INTERLACE_NONE,
		     PNG_COMPRESSION_TYPE_BASE, PNG_FILTER_TYPE_BASE);

	png_write_info(pngptr, info);

	if (setjmp(png_jmpbuf(pngptr)))
		exit(-1);

	png_write_image(pngptr, nurows);

	if (setjmp(png_jmpbuf(pngptr)))
		exit(-1);

	png_write_end(pngptr, NULL);

	free(nurows);
    fclose(fp);
}

byte* extractChannel(byte* img, int width, int height, int offset)
{
	/* insert code here */
	return img;
}

void extractColors()
{	
	byte* redData = extractChannel(imgData, width, height, 0);	
	writesinglechannelpngfile("red.png", redData);

	byte* greenData = extractChannel(imgData, width, height, 1);
	writesinglechannelpngfile("green.png", greenData);
	
	byte* blueData = extractChannel(imgData, width, height, 2);	
	writesinglechannelpngfile("blue.png", blueData);

}

byte* scaleImage(byte* img, float wid, float hei, float nuwidth, float nuheight)
{
	/* insert code here */
	return img;
}

void produceScaledImages(){
	//produce an image half the size
	byte* scaleData = scaleImage(imgData, width, height, width / 2, height / 2);
	writepngfile("half.png", width / 2, height / 2, scaleData);

	free(scaleData);

	//produce an image that's twice as large
	scaleData = scaleImage(imgData, width, height, width * 2, height * 2);
	writepngfile("twice.png", width * 2, height * 2, scaleData);

	free(scaleData);

	//produce an image that's twice as wide and half as high
	scaleData = scaleImage(imgData, width, height, width * 2, height / 2);
	writepngfile("skew.png", width * 2, height / 2, scaleData);

	free(scaleData);
	
}

byte* diffImages(byte* img1, byte* img2, int width, int height)
{
	/* insert code here */
	return img1;
}

void produceDiffImages(){
	byte* diffData = diffImages(imgData, imgData2, width, height);
	writepngfile("diff.png", width, height, diffData);
}

int main(int argc, char **argv)
{
	imgData = loadfile("../res/test1.png");
	imgData2 = loadfile("../res/test2.png");

	//extractColors();
	//produceScaledImages();
	//produceDiffImages();

    return 0;
}
